### WEEKDAY, WEATHER AND DOLLAR ###

# From https://weather.com/weather/today/l/dd6f02c5c38d46dbc588bcb1690ea11cd2c271f7f38717a27e56e40e2bf045e5
# Using beautifulsoup4 to get elements from webpage

import random
import requests
from bs4 import BeautifulSoup
import datetime
from xml.dom import minidom
import collections

# collections.Callable = collections.abc.Callable
import os


def weekday():
    headers = requests.utils.default_headers()
    headers.update(
        {
            "User-Agent": "Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:52.0) Gecko/20100101 Firefox/52.0",
        }
    )
    # WEEKDAY
    weekday = requests.get("https://www.calendarr.com/brasil/", headers=headers)
    soup = BeautifulSoup(weekday.text, "html.parser")

    result = soup.find("b").string
    print(result)


def weather():
    headers = requests.utils.default_headers()
    headers.update(
        {
            "User-Agent": "Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:52.0) Gecko/20100101 Firefox/52.0",
        }
    )
    # WEATHER
    r = requests.get(
        "https://weather.com/pt-BR/weather/today/l/dd6f02c5c38d46dbc588bcb1690ea11cd2c271f7f38717a27e56e40e2bf045e5",
        headers=headers,
    )
    soup = BeautifulSoup(r.text, "html.parser")

    results = soup.findAll("span", {"data-testid": "TemperatureValue"})

    # print(results)

    current_weather = results[0]
    # Cut current weather tags
    current_weather = str(current_weather)[
        str(current_weather).find(">") + 1 : str(current_weather).find("</")
    ]
    # Cut current weather , leave only 24 and °
    # Example of incoming string: 24<span class="CurrentConditions--degreeSymbol--4RS_X">°
    # Get first two characters
    current_weather = current_weather[:2] + "°"

    print(current_weather)

    max_weather = results[1]

    # Cut max weather tags
    max_weather = str(max_weather)[
        str(max_weather).find(">") + 1 : str(max_weather).find("</")
    ]

    # Remove <span> from string
    max_weather = max_weather.replace("<span>", "")

    min_weather = results[2]

    # Cut min weather tags
    min_weather = str(min_weather)[
        str(min_weather).find(">") + 1 : str(min_weather).find("</")
    ]

    # Remove <span> from string
    min_weather = min_weather.replace("<span>", "")

    # print(min_weather)
    # return

    current_weather = current_weather + "C"
    max_weather = max_weather + "C"
    min_weather = min_weather + "C"

    icon = soup.findAll("title")[10].string

    print(icon)

    # Hora atual da máquina
    hour = datetime.datetime.now().hour
    print(hour)

    # Noite
    if icon == "Clear Night":
        icon = "ClearNight"
    elif icon == "Partly Cloudy Night":
        icon = "CloudyNight"
    elif icon == "Mostly Clear Night":
        icon = "CloudyNight"
    # Dia
    elif icon == "Partly Cloudy":
        icon = "Cloudy"
    elif icon == "Mostly Sunny":
        icon = "Cloudy"
    elif icon == "Sunny":
        icon = "ClearDay"
    # Chuva
    elif icon == "Mostly Cloudy":
        if hour >= 18:
            icon = "CloudyNight"
        else:
            icon = "Cloudy"
    elif icon == "Scattered Showers":
        icon = "Rain"
    elif icon == "Thunderstorm":
        icon = "Thunderstorm"
    elif icon == "Scattered Thunderstorms":
        icon = "Thunderstorm"

    black_icon = icon + "-black"

    weather = [black_icon, icon, current_weather, max_weather, min_weather]
    print(weather)
    return weather


def weatherObj(weathercode):
    # ! DEFINE CLASS #
    class Weather:
        def __init__(self, blackicon, icon, current_weather, max_weather, min_weather):
            self.blackicon = blackicon
            self.icon = icon
            self.current_weather = current_weather
            self.max_weather = max_weather
            self.min_weather = min_weather

    # ? Use request to get weather code
    headers = requests.utils.default_headers()
    # ? Set header as Firefox
    headers.update(
        {
            "User-Agent": "Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:52.0) Gecko/20100101 Firefox/52.0",
        }
    )

    # ! REQUEST #
    r = requests.get(
        "https://weather.com/pt-BR/weather/today/l/" + weathercode,
        headers=headers,
    )

    # ! SOUP #
    soup = BeautifulSoup(r.text, "html.parser")

    # ? Getting currentweather html tag
    results = soup.findAll("span", {"data-testid": "TemperatureValue"})
    # ? Getting currentweather result
    current_weather = results[0]
    # ? Cut current weather tags
    current_weather = str(current_weather)[
        str(current_weather).find(">") + 1 : str(current_weather).find("</")
    ]
    # ? Cut current weather , leave only (Temperature) and °
    current_weather = current_weather[:2] + "°"

    # ? Getting maxweather html tag
    max_weather = results[1]
    # ? Cut max weather tags
    max_weather = str(max_weather)[
        str(max_weather).find(">") + 1 : str(max_weather).find("</")
    ]
    # ? Remove <span> from string
    max_weather = max_weather.replace("<span>", "")

    # ? Getting minweather html tag
    min_weather = results[2]
    # ? Cut min weather tags
    min_weather = str(min_weather)[
        str(min_weather).find(">") + 1 : str(min_weather).find("</")
    ]
    # ? Remove <span> from string
    min_weather = min_weather.replace("<span>", "")

    # ? Setting variables with Celsius (C)
    current_weather = current_weather + "C"
    max_weather = max_weather + "C"
    min_weather = min_weather + "C"

    # ? Getting icon html tag
    icon = soup.findAll("title")[10].string

    # ? Hora atual da máquina
    hour = datetime.datetime.now().hour

    # ? Noite
    if icon == "Clear Night":
        icon = "ClearNight"
    elif icon == "Partly Cloudy Night":
        icon = "CloudyNight"
    elif icon == "Mostly Clear Night":
        icon = "CloudyNight"

    # ? Dia
    elif icon == "Partly Cloudy":
        icon = "Cloudy"
    elif icon == "Mostly Sunny":
        icon = "Cloudy"
    elif icon == "Sunny":
        icon = "ClearDay"

    # ? Chuva
    elif icon == "Mostly Cloudy":
        if hour >= 18:
            icon = "CloudyNight"
        else:
            icon = "Cloudy"
    elif icon == "Scattered Showers":
        icon = "Rain"
    elif icon == "Thunderstorm":
        icon = "Thunderstorm"
    elif icon == "Scattered Thunderstorms":
        icon = "Thunderstorm"

    black_icon = icon + "-black"

    weather = Weather(black_icon, icon, current_weather, max_weather, min_weather)
    print(
        weather.blackicon,
        weather.icon,
        weather.max_weather,
        weather.current_weather,
        weather.min_weather,
    )
    return weather


def dollar():
    headers = requests.utils.default_headers()
    headers.update(
        {
            "User-Agent": "Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:52.0) Gecko/20100101 Firefox/52.0",
        }
    )
    # DOLLAR (USD-BRL)
    dollar = requests.get(
        "https://www.google.com/finance/quote/USD-BRL", headers=headers
    )
    soup = BeautifulSoup(dollar.text, "html.parser")

    # Output soup to test.txt UTF-8
    # with open('test.txt', 'w', encoding='utf-8') as f:
    #     f.write(str(soup))

    # Get div with data-target="BRL" and list children
    results = soup.find("div", {"data-target": "BRL"}).contents
    # Find span on list
    result = results[0].find("span").string
    result = result.replace(".", ",")
    current_dollar = result
    # print(current_dollar)
    return current_dollar


def euro():
    headers = requests.utils.default_headers()
    headers.update(
        {
            "User-Agent": "Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:52.0) Gecko/20100101 Firefox/52.0",
        }
    )
    # DOLLAR (USD-BRL)
    dollar = requests.get(
        "https://www.google.com/finance/quote/EUR-BRL", headers=headers
    )
    soup = BeautifulSoup(dollar.text, "html.parser")

    # Output soup to test.txt UTF-8
    # with open('test.txt', 'w', encoding='utf-8') as f:
    #     f.write(str(soup))

    # Get div with data-target="BRL" and list children
    results = soup.find("div", {"data-target": "BRL"}).contents
    # Find span on list
    result = results[0].find("span").string
    result = result.replace(".", ",")
    current_euro = result
    # print(current_euro)
    return current_euro


def commodities():
    headers = requests.utils.default_headers()
    headers.update(
        {
            "User-Agent": "Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:52.0) Gecko/20100101 Firefox/52.0",
        }
    )
    # COMMODITIES
    com = requests.get("https://sanfro.com.br/cotacao-lme.php", headers=headers)
    soup = BeautifulSoup(com.text, "html.parser")

    results = soup.find("tbody")
    soup = BeautifulSoup(str(results), "html.parser")

    results = soup.findAll("td", {"class": "text-center"})

    cobre = "COBRE: " + results[0].string
    aluminio = "ALUMÍNIO: " + results[2].string
    chumbo = "CHUMBO: " + results[4].string
    estanho = "ESTANHO: " + results[6].string
    niquel = "NÍQUEL: " + results[8].string
    zinco = "ZINCO: " + results[10].string

    commodities = [cobre, aluminio, chumbo, estanho, niquel, zinco]
    print(commodities)
    return commodities


def main():
    # weekday()
    item1 = weather()
    item2 = dollar()
    item3 = commodities()
    item4 = euro()

    root = minidom.Document()

    rss = root.createElement("rss")
    root.appendChild(rss)

    xml = root.createElement("channel")
    rss.appendChild(xml)

    title = root.createElement("title")
    title.appendChild(root.createTextNode("Barra Salmeron"))
    xml.appendChild(title)

    link = root.createElement("link")
    link.appendChild(root.createTextNode("https://combovideos.com.br/"))
    xml.appendChild(link)

    description = root.createElement("description")
    description.appendChild(root.createTextNode("Barra Salmeron"))
    xml.appendChild(description)

    lang = root.createElement("language")
    lang.appendChild(root.createTextNode("pt-br"))
    xml.appendChild(lang)

    rootChild = root.createElement("item")
    xml.appendChild(rootChild)
    # imgVar
    itemChild = root.createElement("imgVar")
    itemChild.appendChild(
        root.createTextNode(
            "https://app.combovideos.com.br/weather/" + item1[1] + ".png"
        )
    )
    rootChild.appendChild(itemChild)
    # imgVar2
    itemChild = root.createElement("imgVar2")
    itemChild.appendChild(
        root.createTextNode(
            "https://app.combovideos.com.br/weather/" + item1[0] + ".png"
        )
    )
    rootChild.appendChild(itemChild)
    # weather
    itemChild = root.createElement("weather")
    itemChild.appendChild(root.createTextNode(item1[2]))
    rootChild.appendChild(itemChild)
    # maxtemp
    itemChild = root.createElement("maxtemp")
    itemChild.appendChild(root.createTextNode(item1[3]))
    rootChild.appendChild(itemChild)
    # mintemp
    itemChild = root.createElement("mintemp")
    itemChild.appendChild(root.createTextNode(item1[4]))
    rootChild.appendChild(itemChild)
    # exchange1
    itemChild = root.createElement("exchange1")
    itemChild.appendChild(root.createTextNode(item3[0]))
    rootChild.appendChild(itemChild)
    # exchange2
    itemChild = root.createElement("exchange2")
    itemChild.appendChild(root.createTextNode(item3[1]))
    rootChild.appendChild(itemChild)
    # exchange3
    itemChild = root.createElement("exchange3")
    itemChild.appendChild(root.createTextNode(item3[2]))
    rootChild.appendChild(itemChild)
    # exchange4
    itemChild = root.createElement("exchange4")
    itemChild.appendChild(root.createTextNode(item3[3]))
    rootChild.appendChild(itemChild)
    # exchange5
    itemChild = root.createElement("exchange5")
    itemChild.appendChild(root.createTextNode(item3[4]))
    rootChild.appendChild(itemChild)
    # exchange6
    itemChild = root.createElement("exchange6")
    itemChild.appendChild(root.createTextNode(item3[5]))
    rootChild.appendChild(itemChild)
    # dollar
    itemChild = root.createElement("dollar")
    itemChild.appendChild(root.createTextNode(item2))
    rootChild.appendChild(itemChild)
    # euro
    itemChild = root.createElement("euro")
    itemChild.appendChild(root.createTextNode(item4))
    rootChild.appendChild(itemChild)

    # ! WEATHER V2 ! #
    weatherChild = root.createElement("regionalweather")

    # ? SOROCABA (SP)
    # Weather code from weather.com url
    weather1 = weatherObj(
        "e402371e4dbe85c09a04af4a6ce1b5f4448d9a0c267d9354857df2b73a151e12"
    )
    # Tag for region
    regionChild = weatherChild.appendChild(root.createElement("sorocaba-sp"))
    # Tag for imgVar
    itemChild = root.createElement("imgVar")
    itemChild.appendChild(
        root.createTextNode(
            "https://app.combovideos.com.br/weather/" + weather1.icon + ".png"
        )
    )
    # Append it
    regionChild.appendChild(itemChild)

    # Tag for imgVar2
    itemChild = root.createElement("imgVar2")
    itemChild.appendChild(
        root.createTextNode(
            "https://app.combovideos.com.br/weather/" + weather1.blackicon + ".png"
        )
    )
    # Append it
    regionChild.appendChild(itemChild)

    # Tag for weather
    itemChild = root.createElement("weather")
    itemChild.appendChild(root.createTextNode(weather1.current_weather))
    # Append it
    regionChild.appendChild(itemChild)

    # Tag for maxtemp
    itemChild = root.createElement("maxtemp")
    itemChild.appendChild(root.createTextNode(weather1.max_weather))
    # Append it
    regionChild.appendChild(itemChild)

    # Tag for mintemp
    itemChild = root.createElement("mintemp")
    itemChild.appendChild(root.createTextNode(weather1.min_weather))
    # Append it
    regionChild.appendChild(itemChild)

    # Append it to root
    rootChild.appendChild(weatherChild)

    # ? VALENÇA (RJ)
    # Weather code from weather.com url
    weather1 = weatherObj(
        "801c966fba6db9868eeeb81c96bae2c09cf7a3c3578618559ad5be9e4f2d859a"
    )
    # Tag for region
    regionChild = weatherChild.appendChild(root.createElement("valenca-rj"))
    # Tag for imgVar
    itemChild = root.createElement("imgVar")
    itemChild.appendChild(
        root.createTextNode(
            "https://app.combovideos.com.br/weather/" + weather1.icon + ".png"
        )
    )
    # Append it
    regionChild.appendChild(itemChild)

    # Tag for imgVar2
    itemChild = root.createElement("imgVar2")
    itemChild.appendChild(
        root.createTextNode(
            "https://app.combovideos.com.br/weather/" + weather1.blackicon + ".png"
        )
    )
    # Append it
    regionChild.appendChild(itemChild)

    # Tag for weather
    itemChild = root.createElement("weather")
    itemChild.appendChild(root.createTextNode(weather1.current_weather))
    # Append it
    regionChild.appendChild(itemChild)

    # Tag for maxtemp
    itemChild = root.createElement("maxtemp")
    itemChild.appendChild(root.createTextNode(weather1.max_weather))
    # Append it
    regionChild.appendChild(itemChild)

    # Tag for mintemp
    itemChild = root.createElement("mintemp")
    itemChild.appendChild(root.createTextNode(weather1.min_weather))
    # Append it
    regionChild.appendChild(itemChild)

    # Append it to root
    rootChild.appendChild(weatherChild)

    xml_str = root.toprettyxml(indent="    ")

    save_path_file = "/home/appcombovideosco/public_html/weather/bar-salmeron.xml"
    # save_path_file = "./bar-salmeron.xml"

    with open(save_path_file, "w") as f:
        f.write(xml_str)


if __name__ == "__main__":
    main()
